LOCALEDEF(1)

NAME
localedef - compile locale definition files

SYNOPSIS
localedef [options] outputpath
localedef --list-archive [options]
localedef --delete-from-archive [options] localename ...
localedef --add-to-archive [options] compiledpath
localedef --version
localedef --help
localedef --usage

DESCRIPTION
The localedef program reads the indicated charmap and input files, compiles them to a binary form quickly usable by the locale(7) functions in the C library, and places the output in outputpath.

If outputpath contains a slash character ('/'), it is directly the name of the output directory. In this case, there is a separate output file for each locale category (LC_CTIME, LC_NUMERIC, and so on).

Otherwise, if the --no-archive option is used, outputpath is the name of a subdirectory in /usr/lib/locale where per-category compiled files are placed.

Otherwise, outputpath is the name of a locale and the compiled locale data is added to the archive file /usr/lib/locale/locale-archive.

In any case, localedef aborts if the directory in which it tries to write locale files has not already been created.

If no charmapfile is given, the value POSIX is used by default. If no inputfile is given, or if it is given as a dash (-), localedef reads from standard input.

OPTIONS
Most options can have either short or long forms. If multiple short options are used, they can be combined in one word (for example, -cv is identical to -c -v).

If a short option takes an argument, the argument can be given separately as the next word (-f foo), or it can be written together with the option letter (-ffoo). If a long option takes an argument, the argument can be given separately as the next word, or it can be written as option=argument (--charmap=foo).

  Operation selection options
A few options direct localedef to do something else than compile locale definitions. Only one of these should be used at a time.

--delete-from-archive
    Delete the named locales from the locale archive file.

--list-archive
    List the locales contained in the locale archive file.

--add-to-archive
    Add the compiledpath directories to the locale archive file. The directories should have been created by previous runs of localedef, using --no-archive.

  Other options
Some of the following options are only sensible for some operations; hopefully it is self-evident which ones.

-f charmapfile, --charmap=charmapfile
    Specify the file that defines the symbolic character names that are used by the input file. If the file is in the default directory for character maps, it is not necessary to specify the full pathname. This default directory is printed by localedef --help.

-i inputfile, --inputfile=inputfile
    Specify the locale definition file to compile. If inputfile is not absolute, localedef will also look in the directories specified by the environment variable I18NPATH and in the default directory for locale definition files. This default directory is printed by localedef --help.

-u repertoirefile, --repertoire-map=repertoirefile
    Read mappings from symbolic names to Unicode UCS4 values from repertoirefile.

-A aliasfile, --alias-file=aliasfile
    Use aliasfile to look up aliases for locale names. There is no default aliases file.

--prefix=pathname
    Set prefix to be prepended to the full archive pathname. By default, the prefix is empty. Setting the prefix to foo, the archive would be placed in foo/usr/lib/locale/locale-archive.

-c, --force
    Write the output files even if warnings were generated about the input file.

--old-style
    Create old-style tables.

-v, --verbose
    Generate extra warnings about errors that are normally ignored.

--quiet
    Suppress all notifications and warnings, and report only fatal errors.

--posix
    Conform strictly to POSIX. Implies --verbose. This option currently has no other effect. Posix conformance is assumed if the environment variable POSIXLY_CORRECT is set.

--replace
    Replace a locale in the locale archive file. Without this option, if the locale is in the archive file already, an error occurs.

--no-archive
    Do not use the locale archive file, instead create outputpath as a subdirectory in the same directory as the locale archive file, and create separate output files for locale categories in it.

--help
    Print a usage summary and exit. Also prints the default paths used by localedef.

--usage
    Print a short usage summary and exit.

-V, --version
    Print the version number, license, and disclaimer of warranty for localedef.

ENVIRONMENT

POSIXLY_CORRECT
    The --posix flag is assumed if this environment variable is set.

I18NPATH
    A colon separated list of default directories for locale definition files.

FILES

/usr/share/i18n/charmaps
    Usual default charmap path.

/usr/share/i18n/locales
    Usual default path for locale source files.

/usr/share/i18n/repertoiremaps
    Usual default repertoire map path.

/usr/lib/locale/locale-archive
    Usual default locale archive location.

outputpath/LC_COLLATE
    One of the output files. It describes the rules for comparing strings in the locale's alphabet.

outputpath/LC_CTYPE
    One of the output files. It contains information about character cases and case conversions for the locale.

outputpath/LC_MONETARY
    One of the output files. It describes the way monetary values should be formatted in the locale.

outputpath/LC_MESSAGES/SYS_LC_MESSAGES
    One of the output files. It contains information about the language messages should be printed in, and what an affirmative or negative answer looks like.

outputpath/LC_NUMERIC
    One of the output files. It describes the rules for formatting numbers in the locale.

outputpath/LC_TIME
    One of the output files. It describes the rules for formatting times and dates in the locale.

outputpath/LC_PAPER
    One of the output files. It describes the default paper size in the locale.

outputpath/LC_NAME
    One of the output files. It describes the rules for formatting names in the locale.

outputpath/LC_ADDRESS
    One of the output files. It describes the rules for formatting addresses, and other location information in the locale.

outputpath/LC_TELEPHONE
    One of the output files. It describes the rules for formatting telephone numbers in the locale.

outputpath/LC_MEASUREMENT
    One of the output files. It describes the rules for measurement in the locale, e.g. Metric or other units.

outputpath/LC_IDENTIFICATION
    One of the output files. It identifies the elements within the locale.

EXAMPLES
Compile the locale files for Finnish in the UTF-8 character set and add it to the default locale archive with the name fi_FI.UTF-8:

    localedef -f UTF-8 -i fi_FI fi_FI.UTF-8

The same, but generate files into the current directory (note that the last argument must then contain a slash):

    localedef -f UTF-8 -i fi_FI ./

SEE ALSO
locale(5), locale(7), locale(1)

AUTHOR
The program was written by Ulrich Drepper.

This manual page was written by Richard Braakman <dark@xs4all.nl> on behalf of the Debian GNU/Linux Project and anyone else who wants it. It was amended by Alastair McKinstry <mckinstry@computer.org> to explain new ISO 14652 elements, and amended further by Lars Wirzenius <liw@iki.fi> to document new functionality (as of GNU C library 2.3.5). The manpage is not supported by the GNU libc maintainers and may be out of date.

STANDARDS
This program conforms to the POSIX standard P1003.2